American-transaction costs 1.0.0.0 American option pricer under proportional transaction costs

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
TreeProductAmerican Class Reference

TreeProduct methods for American options More...

`#include <american.h>`

Inheritance diagram for TreeProductAmerican:

List of all members.

## Public Member Functions
virtual coefficient | current_price (const PiecewiseLinear &current, const Portfolio &holdings=Portfolio(0, 0)) const =0
coefficient | expiry () const
virtual PiecewiseLinear | final_hedge (const Spot &spot) const =0
virtual PiecewiseLinear | interim_hedge (const coefficient t, const Spot &spot, const PiecewiseLinear &future_hedge) const =0
Portfolio | next_portfolio (const coefficient t, const Spot &spot, const PiecewiseLinear &future_hedge, const Portfolio &current_portfolio) const
Portfolio | payoff (const coefficient &t, const Spot &spot) const
PiecewiseLinear | payoff_hedge (const coefficient &t, const Spot &spot) const
| TreeProductAmerican (const coefficient expiry, const PayoffBridge &payoff)

## Detailed Description

TreeProduct methods for American options

## Constructor & Destructor Documentation

TreeProductAmerican::TreeProductAmerican | ( | const coefficient | expiry,
|  | const PayoffBridge & | payoff
| ) |  | `[inline]`

## Member Function Documentation

virtual coefficient TreeProduct::current_price | ( | const PiecewiseLinear & | current,
|  | const Portfolio & | holdings = `Portfolio(0, 0)`
| ) |  | const`[pure virtual, inherited]`

Computes current price of option, given the holdings of the investor

Parameters:

  current | Lower boundary of set of hedging portfolios
  holdings | Current holdings of investor

Implemented in TreeProductAmericanBuyer, TreeProductAmericanSeller, TreeProductEuropeanBuyer, and TreeProductEuropeanSeller.

coefficient TreeProduct::expiry | ( |  | ) | const`[inline, inherited]`

Expiry time.

virtual PiecewiseLinear TreeProduct::final_hedge | ( | const Spot & | spot | ) | const`[pure virtual, inherited]`

Finds set of portfolios that hedges the option at its expiry time.

Parameters:

  spot | Price of underlying asset

Returns:
  Piecewise linear function that gives the lower boundary of set of hedging portfolios

Implemented in TreeProductAmericanBuyer, TreeProductAmericanBuyerOptional, TreeProductAmericanSeller, TreeProductAmericanSellerOptional, TreeProductEuropeanBuyerOptional, TreeProductEuropeanSeller, and TreeProductEuropeanSellerOptional.

virtual PiecewiseLinear TreeProduct::interim_hedge | ( | const coefficient | t,
|  | const Spot & | spot,
|  | const PiecewiseLinear & | future_hedge
| ) |  | const`[pure virtual, inherited]`

Finds set of portfolios that hedges the payoff of the option at time t and in the future

Parameters:

  t | Time
  spot | Price of underlying asset
  future_hedge | Piecewise linear function whose epigraph consist of portfolios that hedge the option at all future time steps

Returns:
  Piecewise linear function that gives the lower boundary of set of hedging portfolios

Implemented in TreeProductAmericanBuyer, TreeProductAmericanSeller, and TreeProductEuropean.

Portfolio TreeProduct::next_portfolio | ( | const coefficient | t,
|  | const Spot & | spot,
|  | const PiecewiseLinear & | future_hedge,
|  | const Portfolio & | current_portfolio
| ) |  | const`[inline, inherited]`

Given a portfolio that hedges at the current time, computes a portfolio into which the trader can enter that hedges at all future times

Parameters:

  t | Time
  spot | Price of underlying asset
  future_hedge | Piecewise linear function whose epigraph consist of portfolios that hedge the option at all future time steps
  current_portfolio | Current portfolio. Must correspond to a point in the epigraph of interim_hedge(t, spot, future_hedge) (this is not checked).

Returns:
  Portfolio that will hedge the product over the next time step.

Portfolio TreeProductAmerican::payoff | ( | const coefficient & | t,
|  | const Spot & | spot
| ) |  | const`[inline]`

PiecewiseLinear TreeProductAmerican::payoff_hedge | ( | const coefficient & | t,
|  | const Spot & | spot
| ) |  | const`[inline]`

Finds set of portfolios that hedges the option at any time t before expiry.

Parameters:

  t | Current time
  spot | Price of underlying asset

Returns:
  Piecewise linear function that gives the lower boundary of set of hedging portfolios

The documentation for this class was generated from the following file:

- treeproduct/american.h

All Classes Namespaces Files Functions Variables Typedefs Defines